Index: /main/waeup.sirp/trunk/src/waeup/sirp/app.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/app.py	(revision 7169)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/app.py	(revision 7170)
@@ -10,5 +10,5 @@
 from waeup.sirp.interfaces import (
     IUniversity, IWAeUPSIRPPluggable, IObjectUpgradeEvent, )
-from waeup.sirp.users import UserContainer
+from waeup.sirp.usercontainer import UserContainer
 from waeup.sirp.utils.logger import Logger
 from waeup.sirp.utils.helpers import attrs_to_fields
Index: /main/waeup.sirp/trunk/src/waeup/sirp/app.txt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/app.txt	(revision 7169)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/app.txt	(revision 7170)
@@ -65,5 +65,5 @@
 
   >>> myuniversity['users']
-  <waeup.sirp.users.UserContainer object at 0x...>
+  <waeup.sirp.usercontainer.UserContainer object at 0x...>
 
   >>> myuniversity['datacenter']
Index: /main/waeup.sirp/trunk/src/waeup/sirp/usercontainer.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/usercontainer.py	(revision 7170)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/usercontainer.py	(revision 7170)
@@ -0,0 +1,36 @@
+"""User container for the WAeUP portal.
+"""
+import grok
+from zope.event import notify
+from waeup.sirp.authentication import Account
+from waeup.sirp.interfaces import IUserContainer
+
+class UserContainer(grok.Container):
+    """A container for principals.
+
+    See interfaces.py and users.txt for extensive description.
+    """
+    grok.implements(IUserContainer)
+    grok.require('waeup.manageUsers')
+
+    def addUser(self, name, password, title=None, description=None, roles=[]):
+        """Add a new Account instance, created from parameters.
+        """
+        if title is None:
+            title = name
+        if description is None:
+            description = title
+        self[name] = Account(name, password, title, description, roles)
+
+    def addAccount(self, account):
+        """Add the account passed.
+        """
+        self[account.name] = account
+
+    def delUser(self, name):
+        """Delete user, if an account with the given name exists.
+
+        Do not complain, if the name does not exist.
+        """
+        if name in self.keys():
+            del self[name]
Index: /main/waeup.sirp/trunk/src/waeup/sirp/usercontainer.txt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/usercontainer.txt	(revision 7170)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/usercontainer.txt	(revision 7170)
@@ -0,0 +1,65 @@
+User container for the WAeUP portal
+***********************************
+
+.. :doctest:
+.. :layer: waeup.sirp.testing.WAeUPSIRPUnitTestLayer
+
+Before we can start, we need some password managers available:
+
+    >>> from zope.app.authentication.placelesssetup import (
+    ...   PlacelessSetup)
+    >>> PlacelessSetup().setUp()
+
+We can create a user container which will hold the useraccounts for
+us:
+
+    >>> from waeup.sirp.usercontainer import UserContainer
+    >>> myusers = UserContainer()
+
+We can add users, just by passing a name, a password, and (optionally)
+a title and a description:
+
+    >>> myusers.addUser('bob', 'bobssecret')
+
+Now, Bob is in the container:
+
+    >>> list(myusers)
+    [u'bob']
+
+We can get Bob's account:
+
+    >>> bob = myusers['bob']
+    >>> bob
+    <waeup.sirp.authentication.Account object at 0x...>
+
+    >>> bob.name
+    'bob'
+
+    >>> bob.title
+    'bob'
+
+    >>> bob.description
+    'bob'
+
+As we did not give a title nor description, the name was taken instead
+for these values. The password, however, is stored encoded:
+
+    >>> bob.password
+    '...15aca8166'
+
+Remark: that we can tell the last chars of the 'encrypted' password,
+means, that the encryption is broken or at least waeker as it should
+be.
+
+XXX: We could provide a stronger (correct) SHA encryption.
+
+We can delete users:
+
+    >>> myusers.delUser('alice')
+
+The container won't complain, although there is no ``alice`` stored
+yet. But we can really delete users:
+
+    >>> myusers.delUser('bob')
+    >>> list(myusers)
+    []
Index: in/waeup.sirp/trunk/src/waeup/sirp/users.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/users.py	(revision 7169)
+++ 	(revision )
@@ -1,36 +1,0 @@
-"""User container for the WAeUP portal.
-"""
-import grok
-from zope.event import notify
-from waeup.sirp.authentication import Account
-from waeup.sirp.interfaces import IUserContainer
-
-class UserContainer(grok.Container):
-    """A container for principals.
-
-    See interfaces.py and users.txt for extensive description.
-    """
-    grok.implements(IUserContainer)
-    grok.require('waeup.manageUsers')
-
-    def addUser(self, name, password, title=None, description=None, roles=[]):
-        """Add a new Account instance, created from parameters.
-        """
-        if title is None:
-            title = name
-        if description is None:
-            description = title
-        self[name] = Account(name, password, title, description, roles)
-
-    def addAccount(self, account):
-        """Add the account passed.
-        """
-        self[account.name] = account
-
-    def delUser(self, name):
-        """Delete user, if an account with the given name exists.
-
-        Do not complain, if the name does not exist.
-        """
-        if name in self.keys():
-            del self[name]
Index: in/waeup.sirp/trunk/src/waeup/sirp/users.txt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/users.txt	(revision 7169)
+++ 	(revision )
@@ -1,65 +1,0 @@
-User container for the WAeUP portal
-***********************************
-
-.. :doctest:
-.. :layer: waeup.sirp.testing.WAeUPSIRPUnitTestLayer
-
-Before we can start, we need some password managers available:
-
-    >>> from zope.app.authentication.placelesssetup import (
-    ...   PlacelessSetup)
-    >>> PlacelessSetup().setUp()
-
-We can create a user container which will hold the useraccounts for
-us:
-
-    >>> from waeup.sirp.users import UserContainer
-    >>> myusers = UserContainer()
-
-We can add users, just by passing a name, a password, and (optionally)
-a title and a description:
-
-    >>> myusers.addUser('bob', 'bobssecret')
-
-Now, Bob is in the container:
-
-    >>> list(myusers)
-    [u'bob']
-
-We can get Bob's account:
-
-    >>> bob = myusers['bob']
-    >>> bob
-    <waeup.sirp.authentication.Account object at 0x...>
-
-    >>> bob.name
-    'bob'
-
-    >>> bob.title
-    'bob'
-
-    >>> bob.description
-    'bob'
-
-As we did not give a title nor description, the name was taken instead
-for these values. The password, however, is stored encoded:
-
-    >>> bob.password
-    '...15aca8166'
-
-Remark: that we can tell the last chars of the 'encrypted' password,
-means, that the encryption is broken or at least waeker as it should
-be.
-
-XXX: We could provide a stronger (correct) SHA encryption.
-
-We can delete users:
-
-    >>> myusers.delUser('alice')
-
-The container won't complain, although there is no ``alice`` stored
-yet. But we can really delete users:
-
-    >>> myusers.delUser('bob')
-    >>> list(myusers)
-    []