Index: main/waeup.sirp/trunk/src/waeup/sirp/authentication.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/authentication.py	(revision 7176)
+++ main/waeup.sirp/trunk/src/waeup/sirp/authentication.py	(revision 7177)
@@ -76,5 +76,5 @@
         self.description = description
         self.setPassword(password)
-        self.setRoles(roles)
+        #self.setSiteRolesForPrincipal(roles)
         # We don't want to share this dict with other accounts
         self._local_roles = dict()
@@ -88,5 +88,5 @@
         return passwordmanager.checkPassword(self.password, password)
 
-    def getRoles(self):
+    def getSiteRolesForPrincipal(self):
         prm = get_principal_role_manager()
         roles = [x[0] for x in prm.getRolesForPrincipal(self.name)
@@ -94,17 +94,15 @@
         return roles
 
-    def setRoles(self, roles):
+    def setSiteRolesForPrincipal(self, roles):
         prm = get_principal_role_manager()
-
-        old_roles = self.getRoles()
+        old_roles = self.getSiteRolesForPrincipal()
         for role in old_roles:
             # Remove old roles, not to be set now...
             if role.startswith('waeup.') and role not in roles:
                 prm.unsetRoleForPrincipal(role, self.name)
-
         for role in roles:
             prm.assignRoleToPrincipal(role, self.name)
 
-    roles = property(getRoles, setRoles)
+    roles = property(getSiteRolesForPrincipal, setSiteRolesForPrincipal)
 
     def getLocalRoles(self):
Index: main/waeup.sirp/trunk/src/waeup/sirp/authentication.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/authentication.txt	(revision 7176)
+++ main/waeup.sirp/trunk/src/waeup/sirp/authentication.txt	(revision 7177)
@@ -53,5 +53,5 @@
 Users have also got the global PortalUser role:
 
-  >>> alice.getRoles()
+  >>> alice.getSiteRolesForPrincipal()
   ['waeup.PortalUser']
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 7176)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 7177)
@@ -16,5 +16,4 @@
 from waeup.sirp.students.interfaces import IStudentNavigation
 from waeup.sirp.authentication import get_principal_role_manager
-from waeup.sirp.permissions import getRoles
 
 grok.templatedir('templates')
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7176)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7177)
@@ -37,7 +37,5 @@
     ISessionConfiguration, ISessionConfigurationAdd, academic_sessions_vocab,
     IPasswordValidator)
-from waeup.sirp.permissions import (
-    get_users_with_local_roles,
-    getGlobalRolesForAccount, getLocalRolesForAccount)
+from waeup.sirp.permissions import get_users_with_local_roles, getAllRoles
 from waeup.sirp.university.catalog import search
 from waeup.sirp.university.vocabularies import course_levels
@@ -263,8 +261,24 @@
 
     def getLocalRoles(self, account):
-        return getLocalRolesForAccount(self, account)
+        local_roles = account.getLocalRoles()
+        local_roles_string = ''
+        site_url = self.url(grok.getSite())
+        for local_role in local_roles.keys():
+            role_title = dict(getAllRoles())[local_role].title
+            objects_string = ''
+            for object in local_roles[local_role]:
+                objects_string += '<a href="%s">%s</a>, ' %(self.url(object),
+                    self.url(object).replace(site_url,''))
+            local_roles_string += '%s: <br />%s <br />' %(role_title,
+                objects_string.rstrip(', '))
+        return local_roles_string
 
     def getGlobalRoles(self, account):
-        return getGlobalRolesForAccount(account)
+        global_roles = account.roles
+        global_roles_string = ''
+        for global_role in global_roles:
+            role_title = dict(getAllRoles())[global_role].title
+            global_roles_string += '%s <br />' % role_title
+        return global_roles_string
 
 class AddUserFormPage(WAeUPAddFormPage):
Index: main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 7176)
+++ main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 7177)
@@ -86,6 +86,6 @@
     def getTitle(self, value):
         # late import: in interfaces we should not import local modules
-        from waeup.sirp.permissions import getRoles
-        roles = dict(getRoles())
+        from waeup.sirp.permissions import getAllRoles
+        roles = dict(getAllRoles())
         if value in roles.keys():
             title = roles[value].title
Index: main/waeup.sirp/trunk/src/waeup/sirp/permissions.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/permissions.py	(revision 7176)
+++ main/waeup.sirp/trunk/src/waeup/sirp/permissions.py	(revision 7177)
@@ -85,5 +85,5 @@
                      'waeup.viewHostels', 'waeup.manageHostels')
 
-def getRoles():
+def getAllRoles():
     """Return a list of tuples ``<ROLE-NAME>, <ROLE>``.
     """
@@ -102,5 +102,5 @@
     Returns a generator of the found roles.
     """
-    for name, item in getRoles():
+    for name, item in getAllRoles():
         if not name.startswith('waeup.'):
             # Ignore non-WAeUP roles...
@@ -120,29 +120,29 @@
     return sorted([x.id for x in getWAeUPRoles()])
 
-def getLocalRolesForAccount(view, account):
-    """Return HTML tagged string with all local roles of a user account.
-    """
-    local_roles = account.getLocalRoles()
-    local_roles_string = ''
-    site_url = view.url(grok.getSite())
-    for local_role in local_roles.keys():
-        role_title = dict(getRoles())[local_role].title
-        objects_string = ''
-        for object in local_roles[local_role]:
-            objects_string += '<a href="%s">%s</a>, ' %(view.url(object),
-                view.url(object).replace(site_url,''))
-        local_roles_string += '%s: <br />%s <br />' %(role_title,
-            objects_string.rstrip(', '))
-    return local_roles_string
-
-def getGlobalRolesForAccount(account):
-    """Return HTML tagged string with all global roles of a user account.
-    """
-    global_roles = account.roles
-    global_roles_string = ''
-    for global_role in global_roles:
-        role_title = dict(getRoles())[global_role].title
-        global_roles_string += '%s <br />' % role_title
-    return global_roles_string
+#def getLocalRolesForAccount(view, account):
+#    """Return HTML tagged string with all local roles of a user account.
+#    """
+#    local_roles = account.getLocalRoles()
+#    local_roles_string = ''
+#    site_url = view.url(grok.getSite())
+#    for local_role in local_roles.keys():
+#        role_title = dict(getAllRoles())[local_role].title
+#        objects_string = ''
+#        for object in local_roles[local_role]:
+#            objects_string += '<a href="%s">%s</a>, ' %(view.url(object),
+#                view.url(object).replace(site_url,''))
+#        local_roles_string += '%s: <br />%s <br />' %(role_title,
+#            objects_string.rstrip(', '))
+#    return local_roles_string
+
+#def getGlobalRolesForAccount(account):
+#    """Return HTML tagged string with all global roles of a user account.
+#    """
+#    global_roles = account.roles
+#    global_roles_string = ''
+#    for global_role in global_roles:
+#        role_title = dict(getAllRoles())[global_role].title
+#        global_roles_string += '%s <br />' % role_title
+#    return global_roles_string
 
 def getMyRoles(view):
@@ -183,5 +183,5 @@
         self.context = context
         role_ids = getattr(context, 'local_roles', self._roles)
-        self._roles = [(name, role) for name, role in getRoles()
+        self._roles = [(name, role) for name, role in getAllRoles()
                        if name in role_ids]
         return
@@ -214,5 +214,5 @@
         user = grok.getSite()['users'].get(user_name,None)
         user_title = getattr(user, 'description', user_name)
-        local_role_title = dict(getRoles())[local_role].title
+        local_role_title = dict(getAllRoles())[local_role].title
         yield dict(user_name = user_name,
                    user_title = user_title,
Index: main/waeup.sirp/trunk/src/waeup/sirp/permissions.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/permissions.txt	(revision 7176)
+++ main/waeup.sirp/trunk/src/waeup/sirp/permissions.txt	(revision 7177)
@@ -13,6 +13,6 @@
 roles.
 
-:func:`getRoles`
-----------------
+:func:`getAllRoles`
+-------------------
 
 Gives us all roles defined in a WAeUP SIRP portal. We get tuples of
@@ -24,9 +24,9 @@
 with the ZCA (a string) and ``<ROLE>`` is the real role object.
 
-    >>> from waeup.sirp.permissions import getRoles
-    >>> getRoles()
+    >>> from waeup.sirp.permissions import getAllRoles
+    >>> getAllRoles()
     <generator object...at 0x...>
 
-    >>> sorted(list(getRoles()))
+    >>> sorted(list(getAllRoles()))
     [(u'waeup.AccommodationOfficer', <waeup.sirp.hostels.permissions.AccommodationOfficer object at 0x...]
 