Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py	(revision 7178)
@@ -42,5 +42,5 @@
     grok.permissions('waeup.handleApplication', 'waeup.viewApplication')
 
-# Global role
+# Site role
 
 class ApplicantRole(grok.Role):
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 7178)
@@ -139,6 +139,6 @@
   >>> browser.getControl("Cancel", index=0).click()
 
-We can add global roles which are then displayed on the user container page.
-Since the test browser does not use javascript, we have to add global roles
+We can add site roles which are then displayed on the user container page.
+Since the test browser does not use javascript, we have to add site roles
 manually by setting the roles attribute:
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7178)
@@ -274,11 +274,11 @@
         return local_roles_string
 
-    def getGlobalRoles(self, account):
-        global_roles = account.roles
-        global_roles_string = ''
-        for global_role in global_roles:
-            role_title = dict(getAllRoles())[global_role].title
-            global_roles_string += '%s <br />' % role_title
-        return global_roles_string
+    def getSiteRoles(self, account):
+        site_roles = account.roles
+        site_roles_string = ''
+        for site_role in site_roles:
+            role_title = dict(getAllRoles())[site_role].title
+            site_roles_string += '%s <br />' % role_title
+        return site_roles_string
 
 class AddUserFormPage(WAeUPAddFormPage):
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/userscontainerpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/userscontainerpage.pt	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/userscontainerpage.pt	(revision 7178)
@@ -11,6 +11,6 @@
       <th>Name</th>
       <th>Description</th>
-      <th>Global roles</th>
-      <th>Local roles</th>
+      <th>Portal Roles</th>
+      <th>Local Roles</th>
       <th></th>
     </tr>
@@ -21,6 +21,6 @@
       <td tal:content="account/title">Title</td>
       <td tal:content="account/description">Description</td>
-      <td tal:content="structure python:view.getGlobalRoles(account)">Global Roles</td>
-      <td tal:content="structure python:view.getLocalRoles(account)">Local Roles</td>
+      <td tal:content="structure python:view.getSiteRoles(account)">SITE ROLES</td>
+      <td tal:content="structure python:view.getLocalRoles(account)">LOCAL ROLES</td>
       <td class="text-right">
         <form method="post">
Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/permissions.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/permissions.py	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/permissions.py	(revision 7178)
@@ -27,5 +27,5 @@
     grok.name('waeup.manageHostels')
 
-# Global Roles
+# Site Roles
 class AccommodationOfficer(grok.Role):
     grok.name('waeup.AccommodationOfficer')
Index: main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/interfaces.py	(revision 7178)
@@ -77,5 +77,5 @@
 
 class RoleSource(BasicSourceFactory):
-    """A source for global roles.
+    """A source for site roles.
     """
     def getValues(self):
@@ -189,5 +189,5 @@
         required = False,)
     roles = schema.List(
-        title = u'Global roles',
+        title = u'Portal roles',
         value_type = schema.Choice(source=RoleSource()))
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/permissions.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/permissions.py	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/permissions.py	(revision 7178)
@@ -67,5 +67,5 @@
     grok.permissions('waeup.editUser')
 
-# Global Roles
+# Site Roles
 class PortalUser(grok.Role):
     grok.name('waeup.PortalUser')
@@ -119,39 +119,4 @@
     """
     return sorted([x.id for x in getWAeUPRoles()])
-
-#def getLocalRolesForAccount(view, account):
-#    """Return HTML tagged string with all local roles of a user account.
-#    """
-#    local_roles = account.getLocalRoles()
-#    local_roles_string = ''
-#    site_url = view.url(grok.getSite())
-#    for local_role in local_roles.keys():
-#        role_title = dict(getAllRoles())[local_role].title
-#        objects_string = ''
-#        for object in local_roles[local_role]:
-#            objects_string += '<a href="%s">%s</a>, ' %(view.url(object),
-#                view.url(object).replace(site_url,''))
-#        local_roles_string += '%s: <br />%s <br />' %(role_title,
-#            objects_string.rstrip(', '))
-#    return local_roles_string
-
-#def getGlobalRolesForAccount(account):
-#    """Return HTML tagged string with all global roles of a user account.
-#    """
-#    global_roles = account.roles
-#    global_roles_string = ''
-#    for global_role in global_roles:
-#        role_title = dict(getAllRoles())[global_role].title
-#        global_roles_string += '%s <br />' % role_title
-#    return global_roles_string
-
-def getMyRoles(view):
-    account = get_user_account(view.request)
-    if account:
-        global_roles = getGlobalRoles(account)
-        local_roles = getLocalRoles(account)
-        return [global_roles,local_roles]
-    return
-
 
 class LocalRolesAssignable(grok.Adapter):
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py	(revision 7177)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/permissions.py	(revision 7178)
@@ -46,5 +46,5 @@
                      'waeup.viewStudent', 'waeup.payStudent')
 
-# Global Roles
+# Site Roles
 class StudentRole(grok.Role):
     grok.name('waeup.Student')